//
//  ViewController.m
//  DQMoveCollectionView
//
//  Created by 邓琪 dengqi on 2016/12/16.
//  Copyright © 2016年 邓琪 dengqi. All rights reserved.
//

#import "ViewController.h"
#import "ModelarCollectionView.h"
#import "DQModel.h"
#import "DQTool.h"
#import "CollectionViewCell.h"

#define KScreenWidth [UIScreen mainScreen].bounds.size.width
#define KScreenHeight [UIScreen mainScreen].bounds.size.height
//每个格子的高度
#define GridHeight 122
//每行显示格子的列数
#define PerRowGridCount 3
//每个格子的宽度
#define GridWidth (KScreenWidth/PerRowGridCount-4)

@interface ViewController ()<UICollectionViewDelegateFlowLayout,UICollectionViewDataSource,RTDragCellTableViewDataSource,RTDragCellTableViewDelegate>

@property (nonatomic, strong) ModelarCollectionView *DQCollectionView;

@property (nonatomic, strong) NSMutableArray <DQModel *> *DataArr;
@end

@implementation ViewController
- (NSMutableArray<DQModel *> *)DataArr{
    if (!_DataArr) {
        _DataArr = [NSMutableArray new];
    }

    return _DataArr;
}
- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor whiteColor];
    UICollectionViewFlowLayout *flowLayout = [[UICollectionViewFlowLayout alloc]init] ;
    flowLayout.itemSize = CGSizeMake(GridWidth, GridHeight) ;
    flowLayout.minimumLineSpacing = 1;
    flowLayout.minimumInteritemSpacing = 1;
    flowLayout.scrollDirection = UICollectionViewScrollDirectionVertical ;
    
    self.DQCollectionView = [[ModelarCollectionView alloc]initWithFrame:CGRectMake(0, 0, KScreenWidth, KScreenHeight) collectionViewLayout:flowLayout] ;
    [self.DQCollectionView registerNib:[UINib nibWithNibName:@"CollectionViewCell" bundle:nil] forCellWithReuseIdentifier:@"cell"] ;
    self.DQCollectionView.delegate = self ;
    self.DQCollectionView.dataSource = self ;
    self.DQCollectionView.adelegate = self ;
    self.DQCollectionView.adataSource = self ;
    self.DQCollectionView.alwaysBounceVertical = YES;
    [self.view addSubview:self.DQCollectionView] ;
    self.DQCollectionView.backgroundColor = [UIColor whiteColor];
    
    NSArray *Arr = @[@"0",@"1",@"2",@"3",@"4",@"7",@"8",@"9"];//假如 这是后面返回 要显示的内容
    
    NSArray *array = [DQTool InitializeDateFunction:Arr];
    self.DataArr = [array mutableCopy];
    [self.DQCollectionView reloadData];
}

- (NSInteger )collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section{
    
    return self.DataArr.count;
}
-(UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath
{
    CollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"cell" forIndexPath:indexPath] ;
    [cell SetDataFromModel:self.DataArr[indexPath.row]];
    return cell ;
}
- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath{

    return CGSizeMake(GridWidth, GridHeight);
}
- (UIEdgeInsets)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout insetForSectionAtIndex:(NSInteger)section
{
    return UIEdgeInsetsMake(1, 1, 1, 1);
}
- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath{
    //点击事件

    
}
- (void)tableView:(ModelarCollectionView *)tableView newArrayDataForDataSource:(NSArray *)newArray{
    //改变数组
    self.DataArr = [NSMutableArray arrayWithArray:newArray] ;
    
}
/**选中的cell完成移动，手势已松开*/
- (void)cellDidEndMovingInTableView:(ModelarCollectionView *)tableView{
    //保存数据
     [DQTool SaveUserDefaultsDataFunction:self.DataArr];

}
- (NSArray *)originalArrayDataForTableView:(ModelarCollectionView *)tableView{
    
    return self.DataArr;
}
@end
